# $Id: composedatefrommods.py 2969 2010-01-25 14:31:42Z anton $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/trunk/sources/meresco/bzv/src/composedatefrommods.py $

from meresco.core import Observable
import re

class ComposeDateFromMods(Observable):
    def __init__(self, fieldName):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}
        self._fieldName = fieldName
        self._re = re.compile("\d{4}|\d{3}X|\d{2}XX|\d{3}-")

    def addXml(self, lxmlNode):
        dates = lxmlNode.xpath('//mods:originInfo/mods:dateIssued/text()', namespaces=self._namespaceMap)
        for date in dates:
            # bij catalogusrecords staat de goede datum soms tussen vierkante haakjes
            altDate = date.split('[', 1)
            if len(altDate) == 2: date = altDate[1].rstrip(']')
            else:
                # of anders tussen ronde haakjes
                altDate = date.split('(', 1)
                if len(altDate) == 2: date = altDate[1].rstrip(')')
            match = self._re.search(date)
            if match:
                date = match.group().replace('X', '0').replace('-', '0')
                yield self.do.addField(name=self._fieldName, value=date)
